2 # install - install a program, script, or datafile
4 scriptversion
=2014-09-12.12
; # UTC
6 # This originates from X11R5 (mit/util/scripts/install.sh), which was
7 # later released in X11R6 (xc/config/util/install.sh) with the
8 # following copyright and license.
10 # Copyright (C) 1994 X Consortium
12 # Permission is hereby granted, free of charge, to any person obtaining a copy
13 # of this software and associated documentation files (the "Software"), to
14 # deal in the Software without restriction, including without limitation the
15 # rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
16 # sell copies of the Software, and to permit persons to whom the Software is
17 # furnished to do so, subject to the following conditions:
19 # The above copyright notice and this permission notice shall be included in
20 # all copies or substantial portions of the Software.
22 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
23 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
24 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
25 # X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
26 # AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
27 # TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
29 # Except as contained in this notice, the name of the X Consortium shall not
30 # be used in advertising or otherwise to promote the sale, use or other deal-
31 # ings in this Software without prior written authorization from the X Consor-
35 # FSF changes to this file are in the public domain.
37 # Calling this script install-sh is preferred over install.sh, to prevent
38 # 'make' implicit rules from creating a file called install from it
39 # when there is no Makefile.
41 # This script is compatible with the BSD install script, but was written
49 # Set DOITPROG to "echo" to test this script.
52 doit_exec
=${doit:-exec}
54 # Put in absolute file names if you don't have them in your path;
55 # or use environment vars.
57 chgrpprog
=${CHGRPPROG-chgrp}
58 chmodprog
=${CHMODPROG-chmod}
59 chownprog
=${CHOWNPROG-chown}
60 cmpprog
=${CMPPROG-cmp}
62 mkdirprog
=${MKDIRPROG-mkdir}
65 stripprog
=${STRIPPROG-strip}
69 # Desired mode of installed file.
85 is_target_a_directory
=possibly
88 Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
89 or: $0 [OPTION]... SRCFILES... DIRECTORY
90 or: $0 [OPTION]... -t DIRECTORY SRCFILES...
91 or: $0 [OPTION]... -d DIRECTORIES...
93 In the 1st form, copy SRCFILE to DSTFILE.
94 In the 2nd and 3rd, copy all SRCFILES to DIRECTORY.
95 In the 4th, create DIRECTORIES.
98 --help display this help and exit.
99 --version display version info and exit.
102 -C install only if different (preserve the last data modification time)
103 -d create directories instead of installing files.
104 -g GROUP $chgrpprog installed files to GROUP.
105 -m MODE $chmodprog installed files to MODE.
106 -o USER $chownprog installed files to USER.
107 -s $stripprog installed files.
108 -t DIRECTORY install into DIRECTORY.
109 -T report an error if DSTFILE is a directory.
111 Environment variables override the default commands:
112 CHGRPPROG CHMODPROG CHOWNPROG CMPPROG CPPROG MKDIRPROG MVPROG
116 while test $# -ne 0; do
120 -C) copy_on_change
=true
;;
124 -g) chgrpcmd
="$chgrpprog $2"
127 --help) echo "$usage"; exit $?
;;
131 *' '* |
*"$tab"* |
*"$nl"* |
*'*'* |
*'?'* |
*'['*)
132 echo "$0: invalid mode: $mode" >&2
137 -o) chowncmd
="$chownprog $2"
140 -s) stripcmd
=$stripprog;;
143 is_target_a_directory
=always
145 # Protect names problematic for 'test' and other utilities.
147 -* |
[=\
(\
)!]) dst_arg
=.
/$dst_arg;;
151 -T) is_target_a_directory
=never
;;
153 --version) echo "$0 $scriptversion"; exit $?
;;
158 -*) echo "$0: invalid option: $1" >&2
166 # We allow the use of options -d and -T together, by making -d
167 # take the precedence; this is for compatibility with GNU install.
169 if test -n "$dir_arg"; then
170 if test -n "$dst_arg"; then
171 echo "$0: target directory not allowed when installing a directory." >&2
176 if test $# -ne 0 && test -z "$dir_arg$dst_arg"; then
177 # When -d is used, all remaining arguments are directories to create.
178 # When -t is used, the destination is already specified.
179 # Otherwise, the last argument is the destination. Remove it from $@.
182 if test -n "$dst_arg"; then
183 # $@ is not empty: it contains at least $arg.
184 set fnord
"$@" "$dst_arg"
189 # Protect names problematic for 'test' and other utilities.
191 -* |
[=\
(\
)!]) dst_arg
=.
/$dst_arg;;
196 if test $# -eq 0; then
197 if test -z "$dir_arg"; then
198 echo "$0: no input file specified." >&2
201 # It's OK to call 'install-sh -d' without argument.
202 # This can happen when creating conditional directories.
206 if test -z "$dir_arg"; then
207 if test $# -gt 1 ||
test "$is_target_a_directory" = always
; then
208 if test ! -d "$dst_arg"; then
209 echo "$0: $dst_arg: Is not a directory." >&2
215 if test -z "$dir_arg"; then
216 do_exit
='(exit $ret); exit $ret'
217 trap "ret=129; $do_exit" 1
218 trap "ret=130; $do_exit" 2
219 trap "ret=141; $do_exit" 13
220 trap "ret=143; $do_exit" 15
222 # Set umask so as not to create temps with too-generous modes.
223 # However, 'strip' requires both read and write access to temps.
225 # Optimize common cases.
230 if test -z "$stripcmd"; then
235 cp_umask
=`expr '(' 777 - $mode % 1000 ')' $u_plus_rw`;;
237 if test -z "$stripcmd"; then
242 cp_umask
=$mode$u_plus_rw;;
248 # Protect names problematic for 'test' and other utilities.
250 -* |
[=\
(\
)!]) src
=.
/$src;;
253 if test -n "$dir_arg"; then
260 # Waiting for this to be detected by the "$cpprog $src $dsttmp" command
261 # might cause directories to be created, which would be especially bad
262 # if $src (and thus $dsttmp) contains '*'.
263 if test ! -f "$src" && test ! -d "$src"; then
264 echo "$0: $src does not exist." >&2
268 if test -z "$dst_arg"; then
269 echo "$0: no destination specified." >&2
274 # If destination is a directory, append the input filename; won't work
275 # if double slashes aren't ignored.
276 if test -d "$dst"; then
277 if test "$is_target_a_directory" = never
; then
278 echo "$0: $dst_arg: Is a directory" >&2
282 dst
=$dstdir/`basename "$src"`
285 dstdir
=`dirname "$dst"`
291 obsolete_mkdir_used
=false
293 if test $dstdir_status != 0; then
296 # Create intermediate dirs using mode 755 as modified by the umask.
297 # This is like FreeBSD 'install' as of 1997-10-28.
299 case $stripcmd.
$umask in
300 # Optimize common cases.
301 *[2367][2367]) mkdir_umask
=$umask;;
302 .
*0[02][02] | .
[02][02] | .
[02]) mkdir_umask
=22;;
305 mkdir_umask
=`expr $umask + 22 \
306 - $umask % 100 % 40 + $umask % 20 \
307 - $umask % 10 % 4 + $umask % 2
309 *) mkdir_umask
=$umask,go-w
;;
312 # With -d, create the new directory with the user-specified mode.
313 # Otherwise, rely on $mkdir_umask.
314 if test -n "$dir_arg"; then
323 # POSIX mkdir -p sets u+wx bits regardless of umask, which
324 # is incompatible with FreeBSD 'install' when (umask & 300) != 0.
327 # $RANDOM is not portable (e.g. dash); use it when possible to
328 # lower collision chance
329 tmpdir
=${TMPDIR-/tmp}/ins
$RANDOM-$$
330 trap 'ret=$?; rmdir "$tmpdir/a/b" "$tmpdir/a" "$tmpdir" 2>/dev/null; exit $ret' 0
332 # As "mkdir -p" follows symlinks and we work in /tmp possibly; so
333 # create the $tmpdir first (and fail if unsuccessful) to make sure
334 # that nobody tries to guess the $tmpdir name.
335 if (umask $mkdir_umask &&
336 $mkdirprog $mkdir_mode "$tmpdir" &&
337 exec $mkdirprog $mkdir_mode -p -- "$tmpdir/a/b") >/dev
/null
2>&1
339 if test -z "$dir_arg" ||
{
340 # Check for POSIX incompatibilities with -m.
341 # HP-UX 11.23 and IRIX 6.5 mkdir -m -p sets group- or
342 # other-writable bit of parent directory when it shouldn't.
343 # FreeBSD 6.1 mkdir -m -p sets mode of existing directory.
344 test_tmpdir
="$tmpdir/a"
345 ls_ld_tmpdir
=`ls -ld "$test_tmpdir"`
346 case $ls_ld_tmpdir in
347 d????
-?r-
*) different_mode
=700;;
348 d????
-?
--*) different_mode
=755;;
351 $mkdirprog -m$different_mode -p -- "$test_tmpdir" && {
352 ls_ld_tmpdir_1
=`ls -ld "$test_tmpdir"`
353 test "$ls_ld_tmpdir" = "$ls_ld_tmpdir_1"
358 rmdir "$tmpdir/a/b" "$tmpdir/a" "$tmpdir"
360 # Remove any dirs left behind by ancient mkdir implementations.
361 rmdir .
/$mkdir_mode .
/-p .
/-- "$tmpdir" 2>/dev
/null
369 umask $mkdir_umask &&
370 $doit_exec $mkdirprog $mkdir_mode -p -- "$dstdir"
375 # The umask is ridiculous, or mkdir does not conform to POSIX,
376 # or it failed possibly due to a race condition. Create the
377 # directory the slow way, step by step, checking for races as we go.
381 [-=\
(\
)!]*) prefix
='./';;
397 test X
"$d" = X
&& continue
400 if test -d "$prefix"; then
403 if $posix_mkdir; then
404 (umask=$mkdir_umask &&
405 $doit_exec $mkdirprog $mkdir_mode -p -- "$dstdir") && break
406 # Don't fail if two instances are running concurrently.
407 test -d "$prefix" ||
exit 1
410 *\'*) qprefix
=`echo "$prefix" | sed "s/'/'\\\\\\\\''/g"`;;
413 prefixes
="$prefixes '$qprefix'"
419 if test -n "$prefixes"; then
420 # Don't fail if two instances are running concurrently.
421 (umask $mkdir_umask &&
422 eval "\$doit_exec \$mkdirprog $prefixes") ||
423 test -d "$dstdir" ||
exit 1
424 obsolete_mkdir_used
=true
429 if test -n "$dir_arg"; then
430 { test -z "$chowncmd" ||
$doit $chowncmd "$dst"; } &&
431 { test -z "$chgrpcmd" ||
$doit $chgrpcmd "$dst"; } &&
432 { test "$obsolete_mkdir_used$chowncmd$chgrpcmd" = false ||
433 test -z "$chmodcmd" ||
$doit $chmodcmd $mode "$dst"; } ||
exit 1
436 # Make a couple of temp file names in the proper directory.
437 dsttmp
=$dstdir/_inst.$
$_
438 rmtmp
=$dstdir/_rm.$
$_
440 # Trap to clean up those temp files at exit.
441 trap 'ret=$?; rm -f "$dsttmp" "$rmtmp" && exit $ret' 0
443 # Copy the file name to the temp name.
444 (umask $cp_umask && $doit_exec $cpprog "$src" "$dsttmp") &&
446 # and set any options; do chmod last to preserve setuid bits.
448 # If any of these fail, we abort the whole thing. If we want to
449 # ignore errors from any of these, just make sure not to ignore
450 # errors from the above "$doit $cpprog $src $dsttmp" command.
452 { test -z "$chowncmd" ||
$doit $chowncmd "$dsttmp"; } &&
453 { test -z "$chgrpcmd" ||
$doit $chgrpcmd "$dsttmp"; } &&
454 { test -z "$stripcmd" ||
$doit $stripcmd "$dsttmp"; } &&
455 { test -z "$chmodcmd" ||
$doit $chmodcmd $mode "$dsttmp"; } &&
457 # If -C, don't bother to copy if it wouldn't change the file.
458 if $copy_on_change &&
459 old
=`LC_ALL=C ls -dlL "$dst" 2>/dev/null` &&
460 new
=`LC_ALL=C ls -dlL "$dsttmp" 2>/dev/null` &&
462 set X
$old && old
=:$2:$4:$5:$6 &&
463 set X
$new && new
=:$2:$4:$5:$6 &&
465 test "$old" = "$new" &&
466 $cmpprog "$dst" "$dsttmp" >/dev
/null
2>&1
470 # Rename the file to the real destination.
471 $doit $mvcmd -f "$dsttmp" "$dst" 2>/dev
/null ||
473 # The rename failed, perhaps because mv can't rename something else
474 # to itself, or perhaps because mv is so ancient that it does not
477 # Now remove or move aside any old file at destination location.
478 # We try this two ways since rm can't unlink itself on some
479 # systems and the destination file might be busy for other
480 # reasons. In this case, the final cleanup might fail but the new
481 # file should still install successfully.
484 $doit $rmcmd -f "$dst" 2>/dev
/null ||
485 { $doit $mvcmd -f "$dst" "$rmtmp" 2>/dev
/null
&&
486 { $doit $rmcmd -f "$rmtmp" 2>/dev
/null
; :; }
488 { echo "$0: cannot unlink or rename $dst" >&2
493 # Now rename the file to the real destination.
494 $doit $mvcmd "$dsttmp" "$dst"
503 # eval: (add-hook 'write-file-hooks 'time-stamp)
504 # time-stamp-start: "scriptversion="
505 # time-stamp-format: "%:y-%02m-%02d.%02H"
506 # time-stamp-time-zone: "UTC"
507 # time-stamp-end: "; # UTC"